' This program is provided as Freeware for personal, educational
' and non-commercial use under a GNU General Public License.
'
' Written by Mike Perks (basicx@austin.rr.com), 2006
'
' Written for ZBasic Application Note AN-210
'
Option Explicit
Option Strict On

Private TaskStack(1 to 50) as Byte	' task stack
Private count as Integer 			' counter

' main routine
Public Sub Main()
	Dim time as Single
	time = Timer()

	count = 0
	CallTask "counter", TaskStack
	
	Call Sleep(20) ' change this value to see different results 
	Call Counter()

	' Wait for second task to finish if it hasn't already
	Call Sleep(1.0)
	Debug.Print "Final count is ";CStr(count);" after ";CStr(Fmt(Timer()-time,2));" seconds"	
End Sub

' common counting routine
Private Sub counter()
	Dim I as Integer
	Dim tempCount as Integer
	For I= 1 to 10
		tempCount = count
		Call Sleep(2)
		If (tempCount <> count) Then
			Debug.print CStr(Register.TaskCurrent);" wrong value"
		End If
		count = tempCount + 1
	Next
End Sub
